/***********************************************************************/
/*                                                                     */
/*  FILE        :InfraRed.c                                            */
/*  DATE        :Sat, Jul 11, 2009                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :24                                                    */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.15).    */
/*                                                                     */
/***********************************************************************/

#include    "TA_Firmware\TAF_00D.h"
#include    "TA_Firmware\TAF_00P.h"
#include    "TA_Firmware\Msg_00D.h"
#include "sfr24.h"

#define ROBOPROMEM	0 //FLASH1

#define PULSEW0L	1400
#define PULSEW0U	1700
#define PULSEW1L	1700
#define PULSEW1U	1900
#define PULSEW2L	1900
#define PULSEW2U	2100
#define PULSEW3L	2100
#define PULSEW3U	2400

#define IRBASEPORT	210
#define HWID_IRQ	MSG_HWID_RF_SELF
//#define MSG(id,v)	((id)|(((long)v)<<16))

typedef union
{ long asLong;
	struct//lowest bit first
	{ unsigned stat:2; //low order byte, low word
	  unsigned tail:1;
	  unsigned par:1;
	  unsigned mot2d:1;
	  unsigned mot1d:1;
	  unsigned mot4d:1;
	  unsigned mot3d:1;
	  unsigned mot2s:4; //high byte, low word
	  unsigned mot1s:4;
	  unsigned mot4s:4; //low byte high word
	  unsigned mot3s:4;
	  unsigned on:1;	//high byte high word
	  unsigned off:1;
	  unsigned freq:1;
	  unsigned rec:1;
	  unsigned head:4;
	} asStruct;
} IR_type;

typedef void(* irqentry)(void);

irqentry irqtable[64];
typedef int far (*entrypoint)(void);
const static entrypoint progs[3] = {(entrypoint)0x80100, (entrypoint)0xA0100, (entrypoint)0x50100};

IR_type IR_code;
int underflow = 0;

//static unsigned ir1,ir2,ir3,ir4,irt;

#ifdef USE_ROBO_A2
#define UNDERFLOW	(*(char*)0x14a8)
#else
#define UNDERFLOW	underflow 
#endif

void copy_irqtable() //move the firmware irq table E0020 to near RAM
{ char i;
  for (i=0;i<64;i++)
    irqtable[i] = ((irqentry far*)0xE0020)[i];
  asm("FCLR I");
  asm("ldc #_irqtable,INTBL");
  asm("ldc #0,INTBH");
  asm("FSET I");
}

long make_message(char far *id, int val)//scramble message name
{ long rv = 0;
  int i;
  if (id)
    for (i=0; i<3 && id[i]; i++)
	{ rv *= 40;
	  if (id[i]=='!')
	    rv += 39;
	  else if (id[i]=='+')
	    rv += 37;
	  else if (id[i]=='-')
	    rv += 38;
	  else if (id[i]>='0' && id[i]<='9')
	    rv += id[i]-'0'+27;
	  else if (id[i]>='A' && id[i]<='Z')
	    rv += id[i]-'A'+1;
	  else if (id[i]>='a' && id[i]<='z')
	    rv += id[i]-'a'+1;
	}
  return ((long)val<<16)|rv;
}

void send_IR_msg()
{ char subid = 0;
  static long old[4] = {0,0,0,0};
  
//    sTrans.MPWM_Update = 0x01;  // Update PWM values every 10ms

  if (IR_code.asStruct.rec) subid++;
  if (IR_code.asStruct.freq) subid+=2;
  if ((IR_code.asLong^old[subid]) & 0x00f00080L)
  {	int s = IR_code.asStruct.mot3d ? IR_code.asStruct.mot3s : -IR_code.asStruct.mot3s;
	  SendFtMessage(HWID_IRQ, IRBASEPORT+subid, make_message("IR3",s), 0 /*ms*/, MSG_SEND_NORMAL);
  }
  if ((IR_code.asLong^old[subid]) & 0x000f0040L)
  {	int s = IR_code.asStruct.mot4d ? IR_code.asStruct.mot4s : -IR_code.asStruct.mot4s;
	  SendFtMessage(HWID_IRQ, IRBASEPORT+subid, make_message("IR4",s), 0 /*ms*/, MSG_SEND_NORMAL);
  }
  if ((IR_code.asLong^old[subid]) & 0x0000f020L)
  {	int s = IR_code.asStruct.mot1d ? IR_code.asStruct.mot1s : -IR_code.asStruct.mot1s;
/*	  
    	sTrans.MPWM_Main[2] = (IR_code.asStruct.mot1s+1) >> 1;    // PWM for Output O3
    	sTrans.MPWM_Main[3] = (IR_code.asStruct.mot1s+1) >> 1;    // PWM for Output O4
        sTrans.M_Main &= 0xf3;       // switch Output O3/O4 OFF
		if (IR_code.asStruct.mot1s != 0)
          sTrans.M_Main |= IR_code.asStruct.mot1d ? 0x04 : 0x08;       // switch Output O3/O4 ON
*/		  
	SendFtMessage(HWID_IRQ, IRBASEPORT+subid, make_message("IR1",s), 0 /*ms*/, MSG_SEND_NORMAL);
  }
  if ((IR_code.asLong^old[subid]) & 0x00000f10L)
  {	int s = IR_code.asStruct.mot2d ? IR_code.asStruct.mot2s : -IR_code.asStruct.mot2s;
	  SendFtMessage(HWID_IRQ, IRBASEPORT+subid, make_message("IR2",s), 0 /*ms*/, MSG_SEND_NORMAL);
  }
  if ((IR_code.asLong^old[subid]) & 0x03000000L)
  {	int s = 2 * IR_code.asStruct.on + IR_code.asStruct.off;
	  SendFtMessage(HWID_IRQ, IRBASEPORT+subid, make_message("IRT",s), 0 /*ms*/, MSG_SEND_NORMAL);
  }
  old[subid] = IR_code.asLong;
}

#pragma INTERRUPT timerA2
void timerA2(void) //timer (downcounter) to measure length of IR pulses
{ 	if (underflow < 5) 
		underflow++;
	else if (underflow==5)//pause > intermessage pause (max 120ms), timer takes max 33ms to overflow and more than 165ms to overflow 5 times 
	{ IR_code.asLong = 0L;//set all values to neutral
      IR_code.asStruct.stat = 2;
	  send_IR_msg();
	  underflow++;
	}
}

#pragma INTERRUPT int0
void int0(void) //interrupt on any edge of IR signal but use only falling edges
{ static unsigned old;
  static unsigned long code = 0L;
  static char ones = 0;
  static int state = 0;
 
  if (!p8_2) //diff represents the pulse + pause length, ! because IR sensor inverts
  { unsigned val = ta2;
    int diff  = old - val;  // diff should be positive and multiples of 500ns because ta2 is a down counter
    old = val;	  
	  
	if (diff<PULSEW0L || UNDERFLOW>1) // too short or underflow
	{ 	state = 0;
		code  = 0L;
		ones  = 0;
	}
	else if (diff>=PULSEW0L && diff<PULSEW0U)
	{ //code 00 received
		state++;
		code <<=2;
	} else if (diff>=PULSEW1L && diff<PULSEW1U)
	{ //code 01 received
		state++;
		code <<=2;
		code +=1;
		ones ++;
	} else if (diff>=PULSEW2L && diff<PULSEW2U)
	{ //code 10 received
		state++;
		code <<=2;
		code +=2;
		ones++;
	} else if (diff>=PULSEW3L && diff<PULSEW3U)
	{ //code 11 received
		state++;
		code <<=2;
		code +=3;
		ones +=2;
	} else //error, too long, go back to idle state
	{ 	state = 0;
		code  = 0L;
		ones  = 0;
	}
	if (state == 15)//15 pulses and 15 pauses, all bits received
	{//check frame and parity
	  code <<=2;
	  if ((code>>28) == 8 && !(ones&1) && !(code&4))
	  { IR_code.asLong = code;
	    IR_code.asStruct.stat = 2;
	    send_IR_msg();
	  }
	  else
	  { IR_code.asStruct.stat = ones&1 ? 1 : 3; //1=PE,3=FE
	  }
	  code = 0L;
	  state = 0;
	  ones = 0;
	}
    UNDERFLOW = 0; //reset timeout, short timeout is 33-65ms, long timeout is 128-160ms
  }
}

irqentry setIRQhandler(char n, irqentry h)
{ irqentry old = irqtable[n];
  asm("FCLR I");
  irqtable[n] = h;
  asm("FSET I");
  return old;
}

void initIRhandler()
{ setIRQhandler(31,int0);
#ifndef USE_ROBO_A2
  setIRQhandler(7,timerA2);	
#endif
/*
  //precompute message names IR1, IR2 etc.
  ir1 = make_message("IR1",0);
  ir2 = make_message("IR2",0);
  ir3 = make_message("IR3",0);
  ir4 = make_message("IR4",0);
  irt = make_message("IRT",0);
*/
}

void main(void)
{
	copy_irqtable();
	initIRhandler();	
	progs[ROBOPROMEM]();
}
